import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ViewChild, Output, Input, NgModule } from '@angular/core';
import getCaretCoordinates from 'textarea-caret';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { HighlightJsModule } from 'ngx-highlight-js';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTextSuggesterService {
    constructor() { }
}
NgxTextSuggesterService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxTextSuggesterService.ctorParameters = () => [];
/** @nocollapse */ NgxTextSuggesterService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxTextSuggesterService_Factory() { return new NgxTextSuggesterService(); }, token: NgxTextSuggesterService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//t = current time
//b = start value
//c = change in value
//d = duration
/** @type {?} */
const easeInOutQuad = (/**
 * @param {?} t
 * @param {?} b
 * @param {?} c
 * @param {?} d
 * @return {?}
 */
(t, b, c, d) => {
    t /= d / 2;
    if (t < 1) {
        return (c / 2) * t * t + b;
    }
    t--;
    return (-c / 2) * (t * (t - 2) - 1) + b;
});
const ɵ0 = easeInOutQuad;
/** @type {?} */
const scrollToPosition = (/**
 * @param {?} element
 * @param {?} to
 * @param {?} duration
 * @return {?}
 */
(element, to, duration) => {
    /** @type {?} */
    const start = element.scrollTop;
    /** @type {?} */
    const change = to - start;
    /** @type {?} */
    let currentTime = 0;
    /** @type {?} */
    const increment = 20;
    /** @type {?} */
    const animateScroll = (/**
     * @return {?}
     */
    () => {
        currentTime += increment;
        /** @type {?} */
        const val = easeInOutQuad(currentTime, start, change, duration);
        element.scrollTop = val;
        if (currentTime < duration) {
            setTimeout(animateScroll, increment);
        }
    });
    animateScroll();
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTextSuggesterComponent {
    constructor() {
        this.textChange = new EventEmitter();
        this.caretPositon = 0;
        this.currectquery = "";
        this.suggestList = [];
        this.options = { maxLines: 1000, printMargin: false };
        this.codeData = "";
        this.cursorPosition = {
            top: 0,
            left: 0
        };
        this.suggestCodes = ["Backspace", "Space"];
        this.moveCodes = ["ArrowUp", "ArrowDown"];
        this.suggestOptionIndex = -1;
        this.pasteEvent = false;
    }
    /**
     * @param {?} code
     * @param {?} queryTextArea
     * @return {?}
     */
    onChangeInput(code, queryTextArea) {
        this.codeData = code;
        if (this.pasteEvent) {
            this.pasteEvent = false;
            this.codeData = this.codeData.trim();
            queryTextArea.value = this.codeData;
        }
        this.changeCursorPos(queryTextArea);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onPaste(event) {
        this.pasteEvent = true;
    }
    /**
     * @param {?} oField
     * @return {?}
     */
    changeCursorPos(oField) {
        if (oField.selectionStart >= 0) {
            this.caretPositon = oField.selectionStart;
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    updateOnMoveCursor(value) {
        /** @type {?} */
        let curPos = this.caretPositon;
        if (curPos === 0) {
            this.currectquery = "";
            this.resetSuggest();
        }
        if (value[curPos - 1] !== "" && value[curPos - 1] !== undefined) {
            this.currectquery = "";
            while (value[curPos - 1] &&
                value[curPos - 1].trim() !== "" &&
                curPos - 1 >= 0) {
                this.currectquery = value[curPos - 1] + this.currectquery;
                curPos -= 1;
            }
            if (this.currectquery !== "" && this.suggests) {
                this.suggestOptionIndex = 0; // make menu index to 0
                this.suggestList = this.suggests.filter((/**
                 * @param {?} x
                 * @return {?}
                 */
                x => x.name.indexOf(this.currectquery.toUpperCase()) === 0 ||
                    x.name.indexOf(this.currectquery) === 0));
            }
            else {
                this.resetSuggest();
            }
        }
    }
    /**
     * @param {?} queryTextArea
     * @return {?}
     */
    onClickCursor(queryTextArea) {
        this.changeCursorPos(queryTextArea);
    }
    /**
     * @param {?} event
     * @param {?} queryTextArea
     * @return {?}
     */
    checkWord(event, queryTextArea) {
        if (event.keyCode !== 13 && this.suggests) {
            this.changeCursorPos(queryTextArea);
            if (((event.keyCode > 47 && event.keyCode < 58) || // number keys
                event.keyCode === 32 ||
                event.keyCode === 13 || // spacebar & return key(s) (if you want to allow carriage returns)
                (event.keyCode > 64 && event.keyCode < 91) || // letter keys
                (event.keyCode > 95 && event.keyCode < 112) || // numpad keys
                (event.keyCode > 185 && event.keyCode < 193) || // ;=,-./` (in order)
                (event.keyCode > 218 && event.keyCode < 223) ||
                event.keyCode === 16) &&
                event.keyCode !== 32 &&
                event.keyCode !== 86 // ctrl+paste
            ) {
                // scroll suggest list to start before show list
                if (this.suggestList && this.suggestList.length === 0) {
                    scrollToPosition(this.suggestListRef.nativeElement, 0, 100);
                }
                this.currectquery += event.keyCode === 16 ? "" : event.key;
                this.suggestMenuPosition(queryTextArea.selectionStart, queryTextArea.value
                    .substr(0, queryTextArea.selectionStart)
                    .split("\n").length, queryTextArea);
                this.suggestOptionIndex = 0; // make menu index to 0
                this.suggestList = this.suggests.filter((/**
                 * @param {?} x
                 * @return {?}
                 */
                x => x.name.indexOf(this.currectquery.toUpperCase()) === 0 ||
                    x.name.indexOf(this.currectquery) === 0));
                // scroll suggest list to start before show list
                if (this.suggestList && this.suggestList.length === 0) {
                    scrollToPosition(this.suggestListRef.nativeElement, 0, 100);
                }
                this.updateOnMoveCursor(queryTextArea.value);
            }
            else if (this.moveCodes.includes(event.code) &&
                this.suggestList.length > 0) {
                if (this.suggestList &&
                    this.suggestOptionIndex < this.suggestList.length - 1 &&
                    event.code === "ArrowDown") {
                    this.suggestOptionIndex += 1;
                }
                else if (this.suggestOptionIndex > 0 && event.code === "ArrowUp") {
                    this.suggestOptionIndex -= 1;
                }
            }
            else if (event.keyCode === 27) {
                this.resetSuggest();
            }
            else {
                this.currectquery = "";
                this.updateOnMoveCursor(queryTextArea.value);
            }
        }
        this.textChange.emit(queryTextArea.value);
    }
    /**
     * @param {?} textString
     * @param {?} subString
     * @param {?} index
     * @return {?}
     */
    getPosition(textString, subString, index) {
        return textString.split(subString, index).join(subString).length;
    }
    /**
     * @param {?} cursorIndex
     * @param {?} cursorLine
     * @param {?} queryTextArea
     * @return {?}
     */
    suggestMenuPosition(cursorIndex, cursorLine, queryTextArea) {
        /** @type {?} */
        const caret = getCaretCoordinates(queryTextArea, queryTextArea.selectionEnd);
        /** @type {?} */
        const coordinate = queryTextArea.getBoundingClientRect();
        /** @type {?} */
        let startLineIndex = 0;
        if (cursorLine - 1 > 0) {
            startLineIndex = this.getPosition(queryTextArea.value, "\n", cursorLine - 1);
        }
        this.cursorPosition = {
            top: caret.top + caret.height + coordinate.top,
            left: caret.left +
                coordinate.left -
                ((cursorIndex - startLineIndex) / 10) * 10
        };
    }
    /**
     * @param {?} event
     * @param {?} queryTextArea
     * @return {?}
     */
    onKeydown(event, queryTextArea) {
        if (this.suggestList && this.suggestList.length > 0) {
            event.preventDefault();
            if (event.keyCode === 13) {
                this.replaceSuggest(this.suggestList[this.suggestOptionIndex].name, this.currectquery, this.caretPositon, queryTextArea);
                this.resetSuggest();
            }
        }
        else {
            this.currectquery = "";
            this.changeCursorPos(queryTextArea);
        }
        if (this.suggestListRef.nativeElement) {
            scrollToPosition(this.suggestListRef.nativeElement, event.code === "ArrowDown"
                ? this.suggestOptionIndex * 30
                : this.suggestOptionIndex * 30 - 30, 100);
        }
    }
    /**
     * @return {?}
     */
    resetSuggest() {
        this.suggestList = [];
        this.suggestOptionIndex = 0;
    }
    /**
     * @param {?} suggest
     * @param {?} searchText
     * @param {?} endIndex
     * @param {?} queryTextArea
     * @return {?}
     */
    replaceSuggest(suggest, searchText, endIndex, queryTextArea) {
        /** @type {?} */
        let textValue = queryTextArea.value;
        /** @type {?} */
        const startIndex = endIndex - searchText.length;
        /** @type {?} */
        const beforeText = textValue.substring(0, startIndex);
        /** @type {?} */
        const afterText = textValue.substring(endIndex, textValue.length);
        textValue = beforeText + suggest + afterText;
        queryTextArea.value = textValue;
        this.codeData = textValue;
        if (textValue[startIndex + suggest.length] === "\n") {
            this.updateTextAreaCursor(startIndex + suggest.length, queryTextArea);
        }
        else {
            this.updateTextAreaCursor(startIndex + suggest.length + 1, queryTextArea);
        }
    }
    /**
     * @param {?} pos
     * @param {?} queryTextArea
     * @return {?}
     */
    updateTextAreaCursor(pos, queryTextArea) {
        queryTextArea.selectionEnd = pos;
    }
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    compare(a, b) {
        // Use toUpperCase() to ignore character casing
        /** @type {?} */
        const bandA = a.name.toUpperCase();
        /** @type {?} */
        const bandB = b.name.toUpperCase();
        /** @type {?} */
        let comparison = 0;
        if (bandA > bandB) {
            comparison = 1;
        }
        else if (bandA < bandB) {
            comparison = -1;
        }
        return comparison;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (this.suggests && this.sortList) {
            this.suggests = this.suggests.sort(this.compare);
        }
    }
}
NgxTextSuggesterComponent.decorators = [
    { type: Component, args: [{
                selector: "ngx-text-suggester",
                template: `
    <style>
      .main {
        width: calc(100% - 20px);
        height: calc(100% - 20px);
        overflow-y: scroll;
        padding: 10px;
      }
      .main .code-builder-container {
        position: relative;
        width: auto;
        height: auto;
        display: inline-block;
        min-height: 100%;
        min-width: 100%;
      }
      .main .code-builder-container textarea {
        position: absolute;
        right: 0;
        left: 0;
        width: 100%;
        padding: 0;
        background: transparent;
        line-height: 1.45;
        bottom: 0;
        top: 0;
        font-weight: normal;
        word-break: normal;
        overflow: hidden;
        outline: none;
        letter-spacing: 1px;
        font-size: 14px;
        font-family: "Exo 2", sans-serif !important;
        -webkit-text-fill-color: transparent;
        resize: none;
        border: none;
      }
      .main .code-builder-container i {
        font-size: 20px;
        height: 20px;
      }
      .main .code-builder-container .tool-guide {
        position: absolute;
        top: 0;
        display: flex;
        right: 0;
        left: 0;
        height: 40px;
        align-items: center;
      }
      .main .code-builder-container ::ng-deep pre {
        border-radius: 0;
        overflow: hidden;
        letter-spacing: 1px;
        line-height: 1.45;
        font-size: 14px;
        font-family: "Exo 2", sans-serif !important;
        margin: 0;
        padding: 0;
        display: inline-block;
        height: auto;
        margin-bottom: 40px;
        background: transparent;
        margin-right: 80px;
      }
      .main .code-builder-container ::ng-deep pre span {
        letter-spacing: 1px;
        font-size: 14px;
        font-family: "Exo 2", sans-serif !important;
        line-height: 1.45;
        font-weight: initial !important;
      }
      .main .code-builder-container .suggest-options {
        position: fixed;
        max-height: 190px;
        overflow: hidden;
        border-radius: 2px;
        display: flex;
        min-width: 175px;
        border: 1px solid #6aff6a;
        opacity: 0;
        z-index: 10;
      }
      .main .code-builder-container .suggest-options ul {
        list-style: none;
        padding: 10px;
        overflow: auto;
        flex: 1;
        margin: 0;
        display: none;
      }
      .main .code-builder-container .suggest-options ul li {
        display: flex;
        padding: 5px 5px;
      }
      .main .code-builder-container .suggest-options ul li .icon-container {
        margin-right: 5px;
      }
      .main .code-builder-container .suggest-options ul li p {
        border-radius: 3px;
        margin: 0;
        flex: 1;
        padding-left: 5px;
        line-height: 1;
        display: flex;
        align-items: center;
      }
      .main .code-builder-container .suggest-options.show {
        opacity: 1;
      }
      .main .code-builder-container .suggest-options.show ul {
        display: inline-block;
      }
    </style>
    <div
      class="main"
      [ngStyle]="{ background: (mainColors && mainColors.main) || 'black' }"
    >
      <div class="code-builder-container">
        <textarea
          #queryTextArea
          spellcheck="false"
          class="en"
          [ngModel]="codeData"
          (ngModelChange)="onChangeInput($event, queryTextArea)"
          (keyup)="checkWord($event, queryTextArea)"
          (click)="onClickCursor(queryTextArea)"
          (keydown.enter)="onKeydown($event, queryTextArea)"
          (keydown.ArrowDown)="onKeydown($event, queryTextArea)"
          (keydown.ArrowUp)="onKeydown($event, queryTextArea)"
          [ngStyle]="{ color: (mainColors && mainColors.cursor) || '#03A9F4' }"
          (paste)="onPaste($event)"
        >
        </textarea>
        <textarea highlight-js [options]="{}" [lang]="lang">
      {{ codeData }}     
    </textarea>
        <div
          [ngClass]="{ show: suggestList.length > 0 }"
          class="suggest-options"
          [ngStyle]="{
            top: cursorPosition.top + 'px',
            left: cursorPosition.left + 'px',
            background: (menuColors && menuColors.backgroundMenu) || '#FFF'
          }"
        >
          <ul #suggestListRef>
            <li
              *ngFor="let item of suggestList; let i = index"
              [ngClass]="{ active: i === suggestOptionIndex }"
            >
              <div
                class="icon-container"
                *ngIf="item.icon"
                [innerHTML]="item.icon"
                [ngStyle]="{
                  color: (menuColors && menuColors.icons) || '#FFF'
                }"
              ></div>
              <p
                [ngStyle]="{
                  background:
                    i === suggestOptionIndex
                      ? (menuColors && menuColors.activeItem) || 'transparent'
                      : 'transparent',
                  color:
                    i === suggestOptionIndex
                      ? (menuColors && menuColors.activeItemColor) || '#FFF'
                      : null
                }"
              >
                {{ item.name }}
              </p>
            </li>
          </ul>
        </div>
      </div>
    </div>
  `
            }] }
];
/** @nocollapse */
NgxTextSuggesterComponent.ctorParameters = () => [];
NgxTextSuggesterComponent.propDecorators = {
    suggestListRef: [{ type: ViewChild, args: ["suggestListRef", { static: false },] }],
    textareaRef: [{ type: ViewChild, args: ["textareaRef", { static: false },] }],
    textChange: [{ type: Output }],
    lang: [{ type: Input }],
    sortList: [{ type: Input }],
    suggests: [{ type: Input }],
    mainColors: [{ type: Input }],
    menuColors: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggestListRef;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.textareaRef;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.textChange;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.lang;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.sortList;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggests;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.mainColors;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.menuColors;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.caretPositon;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.currectquery;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggestList;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.options;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.codeData;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.cursorPosition;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggestCodes;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.moveCodes;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggestOptionIndex;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.pasteEvent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTextSuggesterModule {
}
NgxTextSuggesterModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxTextSuggesterComponent],
                imports: [HighlightJsModule, CommonModule, FormsModule],
                exports: [NgxTextSuggesterComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxTextSuggesterComponent, NgxTextSuggesterModule, NgxTextSuggesterService };
//# sourceMappingURL=ngx-text-suggester.js.map
