import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ViewChild, Output, Input, NgModule } from '@angular/core';
import getCaretCoordinates from 'textarea-caret';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { HighlightJsModule } from 'ngx-highlight-js';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxTextSuggesterService = /** @class */ (function () {
    function NgxTextSuggesterService() {
    }
    NgxTextSuggesterService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxTextSuggesterService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgxTextSuggesterService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxTextSuggesterService_Factory() { return new NgxTextSuggesterService(); }, token: NgxTextSuggesterService, providedIn: "root" });
    return NgxTextSuggesterService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//t = current time
//b = start value
//c = change in value
//d = duration
/** @type {?} */
var easeInOutQuad = (/**
 * @param {?} t
 * @param {?} b
 * @param {?} c
 * @param {?} d
 * @return {?}
 */
function (t, b, c, d) {
    t /= d / 2;
    if (t < 1) {
        return (c / 2) * t * t + b;
    }
    t--;
    return (-c / 2) * (t * (t - 2) - 1) + b;
});
var ɵ0 = easeInOutQuad;
/** @type {?} */
var scrollToPosition = (/**
 * @param {?} element
 * @param {?} to
 * @param {?} duration
 * @return {?}
 */
function (element, to, duration) {
    /** @type {?} */
    var start = element.scrollTop;
    /** @type {?} */
    var change = to - start;
    /** @type {?} */
    var currentTime = 0;
    /** @type {?} */
    var increment = 20;
    /** @type {?} */
    var animateScroll = (/**
     * @return {?}
     */
    function () {
        currentTime += increment;
        /** @type {?} */
        var val = easeInOutQuad(currentTime, start, change, duration);
        element.scrollTop = val;
        if (currentTime < duration) {
            setTimeout(animateScroll, increment);
        }
    });
    animateScroll();
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxTextSuggesterComponent = /** @class */ (function () {
    function NgxTextSuggesterComponent() {
        this.textChange = new EventEmitter();
        this.caretPositon = 0;
        this.currectquery = "";
        this.suggestList = [];
        this.options = { maxLines: 1000, printMargin: false };
        this.codeData = "";
        this.cursorPosition = {
            top: 0,
            left: 0
        };
        this.suggestCodes = ["Backspace", "Space"];
        this.moveCodes = ["ArrowUp", "ArrowDown"];
        this.suggestOptionIndex = -1;
        this.pasteEvent = false;
    }
    /**
     * @param {?} code
     * @param {?} queryTextArea
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.onChangeInput = /**
     * @param {?} code
     * @param {?} queryTextArea
     * @return {?}
     */
    function (code, queryTextArea) {
        this.codeData = code;
        if (this.pasteEvent) {
            this.pasteEvent = false;
            this.codeData = this.codeData.trim();
            queryTextArea.value = this.codeData;
        }
        this.changeCursorPos(queryTextArea);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.onPaste = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.pasteEvent = true;
    };
    /**
     * @param {?} oField
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.changeCursorPos = /**
     * @param {?} oField
     * @return {?}
     */
    function (oField) {
        if (oField.selectionStart >= 0) {
            this.caretPositon = oField.selectionStart;
        }
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.updateOnMoveCursor = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        /** @type {?} */
        var curPos = this.caretPositon;
        if (curPos === 0) {
            this.currectquery = "";
            this.resetSuggest();
        }
        if (value[curPos - 1] !== "" && value[curPos - 1] !== undefined) {
            this.currectquery = "";
            while (value[curPos - 1] &&
                value[curPos - 1].trim() !== "" &&
                curPos - 1 >= 0) {
                this.currectquery = value[curPos - 1] + this.currectquery;
                curPos -= 1;
            }
            if (this.currectquery !== "" && this.suggests) {
                this.suggestOptionIndex = 0; // make menu index to 0
                this.suggestList = this.suggests.filter((/**
                 * @param {?} x
                 * @return {?}
                 */
                function (x) {
                    return x.name.indexOf(_this.currectquery.toUpperCase()) === 0 ||
                        x.name.indexOf(_this.currectquery) === 0;
                }));
            }
            else {
                this.resetSuggest();
            }
        }
    };
    /**
     * @param {?} queryTextArea
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.onClickCursor = /**
     * @param {?} queryTextArea
     * @return {?}
     */
    function (queryTextArea) {
        this.changeCursorPos(queryTextArea);
    };
    /**
     * @param {?} event
     * @param {?} queryTextArea
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.checkWord = /**
     * @param {?} event
     * @param {?} queryTextArea
     * @return {?}
     */
    function (event, queryTextArea) {
        var _this = this;
        if (event.keyCode !== 13 && this.suggests) {
            this.changeCursorPos(queryTextArea);
            if (((event.keyCode > 47 && event.keyCode < 58) || // number keys
                event.keyCode === 32 ||
                event.keyCode === 13 || // spacebar & return key(s) (if you want to allow carriage returns)
                (event.keyCode > 64 && event.keyCode < 91) || // letter keys
                (event.keyCode > 95 && event.keyCode < 112) || // numpad keys
                (event.keyCode > 185 && event.keyCode < 193) || // ;=,-./` (in order)
                (event.keyCode > 218 && event.keyCode < 223) ||
                event.keyCode === 16) &&
                event.keyCode !== 32 &&
                event.keyCode !== 86 // ctrl+paste
            ) {
                // scroll suggest list to start before show list
                if (this.suggestList && this.suggestList.length === 0) {
                    scrollToPosition(this.suggestListRef.nativeElement, 0, 100);
                }
                this.currectquery += event.keyCode === 16 ? "" : event.key;
                this.suggestMenuPosition(queryTextArea.selectionStart, queryTextArea.value
                    .substr(0, queryTextArea.selectionStart)
                    .split("\n").length, queryTextArea);
                this.suggestOptionIndex = 0; // make menu index to 0
                this.suggestList = this.suggests.filter((/**
                 * @param {?} x
                 * @return {?}
                 */
                function (x) {
                    return x.name.indexOf(_this.currectquery.toUpperCase()) === 0 ||
                        x.name.indexOf(_this.currectquery) === 0;
                }));
                // scroll suggest list to start before show list
                if (this.suggestList && this.suggestList.length === 0) {
                    scrollToPosition(this.suggestListRef.nativeElement, 0, 100);
                }
                this.updateOnMoveCursor(queryTextArea.value);
            }
            else if (this.moveCodes.includes(event.code) &&
                this.suggestList.length > 0) {
                if (this.suggestList &&
                    this.suggestOptionIndex < this.suggestList.length - 1 &&
                    event.code === "ArrowDown") {
                    this.suggestOptionIndex += 1;
                }
                else if (this.suggestOptionIndex > 0 && event.code === "ArrowUp") {
                    this.suggestOptionIndex -= 1;
                }
            }
            else if (event.keyCode === 27) {
                this.resetSuggest();
            }
            else {
                this.currectquery = "";
                this.updateOnMoveCursor(queryTextArea.value);
            }
        }
        this.textChange.emit(queryTextArea.value);
    };
    /**
     * @param {?} textString
     * @param {?} subString
     * @param {?} index
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.getPosition = /**
     * @param {?} textString
     * @param {?} subString
     * @param {?} index
     * @return {?}
     */
    function (textString, subString, index) {
        return textString.split(subString, index).join(subString).length;
    };
    /**
     * @param {?} cursorIndex
     * @param {?} cursorLine
     * @param {?} queryTextArea
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.suggestMenuPosition = /**
     * @param {?} cursorIndex
     * @param {?} cursorLine
     * @param {?} queryTextArea
     * @return {?}
     */
    function (cursorIndex, cursorLine, queryTextArea) {
        /** @type {?} */
        var caret = getCaretCoordinates(queryTextArea, queryTextArea.selectionEnd);
        /** @type {?} */
        var coordinate = queryTextArea.getBoundingClientRect();
        /** @type {?} */
        var startLineIndex = 0;
        if (cursorLine - 1 > 0) {
            startLineIndex = this.getPosition(queryTextArea.value, "\n", cursorLine - 1);
        }
        this.cursorPosition = {
            top: caret.top + caret.height + coordinate.top,
            left: caret.left +
                coordinate.left -
                ((cursorIndex - startLineIndex) / 10) * 10
        };
    };
    /**
     * @param {?} event
     * @param {?} queryTextArea
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.onKeydown = /**
     * @param {?} event
     * @param {?} queryTextArea
     * @return {?}
     */
    function (event, queryTextArea) {
        if (this.suggestList && this.suggestList.length > 0) {
            event.preventDefault();
            if (event.keyCode === 13) {
                this.replaceSuggest(this.suggestList[this.suggestOptionIndex].name, this.currectquery, this.caretPositon, queryTextArea);
                this.resetSuggest();
            }
        }
        else {
            this.currectquery = "";
            this.changeCursorPos(queryTextArea);
        }
        if (this.suggestListRef.nativeElement) {
            scrollToPosition(this.suggestListRef.nativeElement, event.code === "ArrowDown"
                ? this.suggestOptionIndex * 30
                : this.suggestOptionIndex * 30 - 30, 100);
        }
    };
    /**
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.resetSuggest = /**
     * @return {?}
     */
    function () {
        this.suggestList = [];
        this.suggestOptionIndex = 0;
    };
    /**
     * @param {?} suggest
     * @param {?} searchText
     * @param {?} endIndex
     * @param {?} queryTextArea
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.replaceSuggest = /**
     * @param {?} suggest
     * @param {?} searchText
     * @param {?} endIndex
     * @param {?} queryTextArea
     * @return {?}
     */
    function (suggest, searchText, endIndex, queryTextArea) {
        /** @type {?} */
        var textValue = queryTextArea.value;
        /** @type {?} */
        var startIndex = endIndex - searchText.length;
        /** @type {?} */
        var beforeText = textValue.substring(0, startIndex);
        /** @type {?} */
        var afterText = textValue.substring(endIndex, textValue.length);
        textValue = beforeText + suggest + afterText;
        queryTextArea.value = textValue;
        this.codeData = textValue;
        if (textValue[startIndex + suggest.length] === "\n") {
            this.updateTextAreaCursor(startIndex + suggest.length, queryTextArea);
        }
        else {
            this.updateTextAreaCursor(startIndex + suggest.length + 1, queryTextArea);
        }
    };
    /**
     * @param {?} pos
     * @param {?} queryTextArea
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.updateTextAreaCursor = /**
     * @param {?} pos
     * @param {?} queryTextArea
     * @return {?}
     */
    function (pos, queryTextArea) {
        queryTextArea.selectionEnd = pos;
    };
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.compare = /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    function (a, b) {
        // Use toUpperCase() to ignore character casing
        /** @type {?} */
        var bandA = a.name.toUpperCase();
        /** @type {?} */
        var bandB = b.name.toUpperCase();
        /** @type {?} */
        var comparison = 0;
        if (bandA > bandB) {
            comparison = 1;
        }
        else if (bandA < bandB) {
            comparison = -1;
        }
        return comparison;
    };
    /**
     * @return {?}
     */
    NgxTextSuggesterComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (this.suggests && this.sortList) {
            this.suggests = this.suggests.sort(this.compare);
        }
    };
    NgxTextSuggesterComponent.decorators = [
        { type: Component, args: [{
                    selector: "ngx-text-suggester",
                    template: "\n    <style>\n      .main {\n        width: calc(100% - 20px);\n        height: calc(100% - 20px);\n        overflow-y: scroll;\n        padding: 10px;\n      }\n      .main .code-builder-container {\n        position: relative;\n        width: auto;\n        height: auto;\n        display: inline-block;\n        min-height: 100%;\n        min-width: 100%;\n      }\n      .main .code-builder-container textarea {\n        position: absolute;\n        right: 0;\n        left: 0;\n        width: 100%;\n        padding: 0;\n        background: transparent;\n        line-height: 1.45;\n        bottom: 0;\n        top: 0;\n        font-weight: normal;\n        word-break: normal;\n        overflow: hidden;\n        outline: none;\n        letter-spacing: 1px;\n        font-size: 14px;\n        font-family: \"Exo 2\", sans-serif !important;\n        -webkit-text-fill-color: transparent;\n        resize: none;\n        border: none;\n      }\n      .main .code-builder-container i {\n        font-size: 20px;\n        height: 20px;\n      }\n      .main .code-builder-container .tool-guide {\n        position: absolute;\n        top: 0;\n        display: flex;\n        right: 0;\n        left: 0;\n        height: 40px;\n        align-items: center;\n      }\n      .main .code-builder-container ::ng-deep pre {\n        border-radius: 0;\n        overflow: hidden;\n        letter-spacing: 1px;\n        line-height: 1.45;\n        font-size: 14px;\n        font-family: \"Exo 2\", sans-serif !important;\n        margin: 0;\n        padding: 0;\n        display: inline-block;\n        height: auto;\n        margin-bottom: 40px;\n        background: transparent;\n        margin-right: 80px;\n      }\n      .main .code-builder-container ::ng-deep pre span {\n        letter-spacing: 1px;\n        font-size: 14px;\n        font-family: \"Exo 2\", sans-serif !important;\n        line-height: 1.45;\n        font-weight: initial !important;\n      }\n      .main .code-builder-container .suggest-options {\n        position: fixed;\n        max-height: 190px;\n        overflow: hidden;\n        border-radius: 2px;\n        display: flex;\n        min-width: 175px;\n        border: 1px solid #6aff6a;\n        opacity: 0;\n        z-index: 10;\n      }\n      .main .code-builder-container .suggest-options ul {\n        list-style: none;\n        padding: 10px;\n        overflow: auto;\n        flex: 1;\n        margin: 0;\n        display: none;\n      }\n      .main .code-builder-container .suggest-options ul li {\n        display: flex;\n        padding: 5px 5px;\n      }\n      .main .code-builder-container .suggest-options ul li .icon-container {\n        margin-right: 5px;\n      }\n      .main .code-builder-container .suggest-options ul li p {\n        border-radius: 3px;\n        margin: 0;\n        flex: 1;\n        padding-left: 5px;\n        line-height: 1;\n        display: flex;\n        align-items: center;\n      }\n      .main .code-builder-container .suggest-options.show {\n        opacity: 1;\n      }\n      .main .code-builder-container .suggest-options.show ul {\n        display: inline-block;\n      }\n    </style>\n    <div\n      class=\"main\"\n      [ngStyle]=\"{ background: (mainColors && mainColors.main) || 'black' }\"\n    >\n      <div class=\"code-builder-container\">\n        <textarea\n          #queryTextArea\n          spellcheck=\"false\"\n          class=\"en\"\n          [ngModel]=\"codeData\"\n          (ngModelChange)=\"onChangeInput($event, queryTextArea)\"\n          (keyup)=\"checkWord($event, queryTextArea)\"\n          (click)=\"onClickCursor(queryTextArea)\"\n          (keydown.enter)=\"onKeydown($event, queryTextArea)\"\n          (keydown.ArrowDown)=\"onKeydown($event, queryTextArea)\"\n          (keydown.ArrowUp)=\"onKeydown($event, queryTextArea)\"\n          [ngStyle]=\"{ color: (mainColors && mainColors.cursor) || '#03A9F4' }\"\n          (paste)=\"onPaste($event)\"\n        >\n        </textarea>\n        <textarea highlight-js [options]=\"{}\" [lang]=\"lang\">\n      {{ codeData }}     \n    </textarea>\n        <div\n          [ngClass]=\"{ show: suggestList.length > 0 }\"\n          class=\"suggest-options\"\n          [ngStyle]=\"{\n            top: cursorPosition.top + 'px',\n            left: cursorPosition.left + 'px',\n            background: (menuColors && menuColors.backgroundMenu) || '#FFF'\n          }\"\n        >\n          <ul #suggestListRef>\n            <li\n              *ngFor=\"let item of suggestList; let i = index\"\n              [ngClass]=\"{ active: i === suggestOptionIndex }\"\n            >\n              <div\n                class=\"icon-container\"\n                *ngIf=\"item.icon\"\n                [innerHTML]=\"item.icon\"\n                [ngStyle]=\"{\n                  color: (menuColors && menuColors.icons) || '#FFF'\n                }\"\n              ></div>\n              <p\n                [ngStyle]=\"{\n                  background:\n                    i === suggestOptionIndex\n                      ? (menuColors && menuColors.activeItem) || 'transparent'\n                      : 'transparent',\n                  color:\n                    i === suggestOptionIndex\n                      ? (menuColors && menuColors.activeItemColor) || '#FFF'\n                      : null\n                }\"\n              >\n                {{ item.name }}\n              </p>\n            </li>\n          </ul>\n        </div>\n      </div>\n    </div>\n  "
                }] }
    ];
    /** @nocollapse */
    NgxTextSuggesterComponent.ctorParameters = function () { return []; };
    NgxTextSuggesterComponent.propDecorators = {
        suggestListRef: [{ type: ViewChild, args: ["suggestListRef", { static: false },] }],
        textareaRef: [{ type: ViewChild, args: ["textareaRef", { static: false },] }],
        textChange: [{ type: Output }],
        lang: [{ type: Input }],
        sortList: [{ type: Input }],
        suggests: [{ type: Input }],
        mainColors: [{ type: Input }],
        menuColors: [{ type: Input }]
    };
    return NgxTextSuggesterComponent;
}());
if (false) {
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggestListRef;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.textareaRef;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.textChange;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.lang;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.sortList;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggests;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.mainColors;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.menuColors;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.caretPositon;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.currectquery;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggestList;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.options;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.codeData;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.cursorPosition;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggestCodes;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.moveCodes;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.suggestOptionIndex;
    /** @type {?} */
    NgxTextSuggesterComponent.prototype.pasteEvent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxTextSuggesterModule = /** @class */ (function () {
    function NgxTextSuggesterModule() {
    }
    NgxTextSuggesterModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxTextSuggesterComponent],
                    imports: [HighlightJsModule, CommonModule, FormsModule],
                    exports: [NgxTextSuggesterComponent]
                },] }
    ];
    return NgxTextSuggesterModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxTextSuggesterComponent, NgxTextSuggesterModule, NgxTextSuggesterService };
//# sourceMappingURL=ngx-text-suggester.js.map
